// Horizontal derviative
// Displays the derivative of the image and
// the pixel to left and right of it.

// Dave Mitchell, drm@ansto.gov.au, March 2003

// version 2.0

// Acquire foremost image and obtain size and name details

image front:=getfrontimage()
string name=getname(front)
number xsize, ysize
getsize(front, xsize, ysize)
setwindowposition (front, 142, 36)
setwindowsize (front, xsize, ysize)
updateimage(Front)

string unitstring
number scalex, scaley
getunitstring(front, unitstring)
getscale(front, scalex, scaley)


// Some variables

image horizontalL=Exprsize(xsize,ysize,0)
image horizontalR=Exprsize(xsize,ysize,0)
image finalimageL=Exprsize(xsize,ysize,0)
image finalimageR=Exprsize(xsize,ysize,0)

// Calculate the two horizontal offsets

horizontalL=offset(front,-1,0)
horizontalR=offset(front,1,0)


// Calculate and display the derivatives

finalimageL=front-horizontalL
finalimageR=horizontalR-front
showimage(finalimageL)
setwindowposition(finalimageL,176, 82)
setwindowsize(finalimageL, xsize, ysize)
setname(finalimageL, "Left Derivative of "+name)
converttoshort(finalimageL)

setscale(finalimageL, scalex, scaley)
setunitstring(finalimageL, unitstring)


showimage(finalimageR)
setwindowposition(finalimageR,206, 122)
setwindowsize(finalimageR, xsize, ysize)
setname(finalimageR, "Right Derivative of "+name)
converttoshort(finalimageR)

setscale(finalimageR, scalex, scaley)
setunitstring(finalimageR, unitstring)